Changes in PAPPL
================

Changes in v1.3.2
-----------------

- Fixed PWG ImageBox values in raster page header
- Fixed a bug in the "ipp-attribute-fidelity" support
- Fixed printing of 1/2/4-bit grayscale PNG images (Issue #267)
- Fixed a potential buffer overflow in the logging code (Issue #272)
- Fixed reporting of "xxx-k-octet-supported" attributes.
- Updated the Wi-Fi configuration page to support hidden networks.
- Updated the Wi-Fi configuration page reload time to 30 seconds.


Changes in v1.3.1
-----------------

- Fixed auto-add of USB printers
- Updated "ipp-attribute-fidelity" support
- Reduced sleep interval for USB gadget initialization


Changes in v1.3.0
-----------------

- Added debug logging for device management.
- Added support for job hold and release (Issue #15)
- Added support for PNG image scaling using embedded resolution information
  (Issue #65)
- Added `papplLocGetDefaultMediaSizeName` function to get the default media size
  for the current country (Issue #167)
- Added support for localized banners at the top of printer and system web pages
  (Issue #183)
- Added timer APIs to manage periodic tasks (Issue #208)
- Added support for network configuration via callbacks (Issue #217)
- Added APIs to limit the maximum size of JPEG/PNG images (Issue #224)
- Added support for the Clang/GCC ThreadSanitizer with the `--enable-tsanitizer`
  configure option.
- Added Norwegian Bokmål, Polish, and Turkish localizations.
- Added a password visibility button to the Wi-Fi password field.
- Changed names of PAPPL-specific attributes to use "smi55357" prefix.
- Updated USB device code to generate a 1284 device ID and use the manufacturer
  and product strings when necessary (Issue #234)
- Updated the USB gadget code to handle disconnections.
- Updated PAPPL to conform to the new prototype PWG 5100.13 specification
  (Issue #216)
- Fixed a device race condition with job processing.
- Fixed a initialization timing issue with USB gadgets on newer Linux kernels.
- Fixed a potential memory underflow with USB device IDs.
- Fixed web interface support for vendor text options (Issue #142)
- Fixed a potential value overflow when reading SNMP OIDs (Issue #210)
- Fixed more CUPS 2.2.x compatibility issues (Issue #212)
- Fixed a 100% CPU usage bug when cleaning the job history (Issue #218)
- Fixed the default values of `--with-papplstatedir` and `--with-papplsockdir`
  to use the `localstatedir` value (Issue #219)
- Fixed storage of label offsets for printers that implement them.
- Fixed some thread access issues on ARM.
- Fixed when the kernel USB printer driver is unloaded on Linux (Issue #233)
- Fixed `papplDevicePrintf` to allow the "%c" character to be 0.
